package es.virtualgolf.tools;

import es.ucm.look.ar.ar2D.drawables.Text2D;
import es.ucm.look.ar.ar3D.core.Color4;
import es.ucm.look.ar.ar3D.core.drawables.DrawablesDataBase;
import es.ucm.look.ar.ar3D.core.drawables.Entity3D;
import es.ucm.look.ar.ar3D.core.drawables.primitives.Cube;
import es.ucm.look.ar.ar3D.core.drawables.primitives.ObjMesh3D;
import es.ucm.look.ar.ar3D.core.drawables.primitives.Ring;
import es.ucm.look.ar.math.geom.Point3;
import es.ucm.look.data.EntityData;
import es.ucm.look.data.WorldEntity;
import es.ucm.look.data.WorldEntityFactory;
import es.virtualgolf.listeners.MyCameraListener;
import es.virtualgolf.listeners.MyTouchListener;
import es.virtualgolf.views.R;

public class MyWorldEntityFactory extends WorldEntityFactory {
	
	public static final String NAME = "name";
	
	public static final String COLOR = "color";
	
	public static final String MESSAGE = "message";
	
	//Esfera
	ObjMesh3D sphere = DrawablesDataBase.getInstance().getDrawable3D(R.raw.sphere);

	@Override
	public WorldEntity createWorldEntity(EntityData data) {
		WorldEntity we = new WorldEntity( data );
		Entity3D drawable3d = null;

		if (data.getType().equals("banderin")) {
//			drawable3d = new Entity3D(new Cube());
			
			drawable3d = new Entity3D(new Ring(new Point3(3.0f, 3.0f, 3.0f), 1.0f, 3.0f, 4, new Color4(0.0f, 1.0f, 0.0f)));
		} else if (data.getType().equals("bola")) {
			drawable3d = new Entity3D(sphere);
			drawable3d.setMaterial(new Color4(1.0f, 1.0f, 1.0f));
		}

		String color = data.getPropertyValue(COLOR);

		if (color != null)
			if (color.equals("blanco")) {
				drawable3d.setMaterial(new Color4(1.0f, 1.0f, 1.0f));
			} else if (color.equals("verde")) {
				drawable3d.setMaterial(new Color4(0.0f, 1.0f, 0.0f));
			} 
		
		we.setDrawable3D(drawable3d);
		
		we.addTouchListener(new MyTouchListener());
		we.addCameraListener(new MyCameraListener());
		
		
		return we;
	}

}