package es.virtualgolf.tools;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import es.ucm.look.data.EntityData;
import es.ucm.look.data.LookData;
import es.ucm.look.data.WorldEntity;

public class Operaciones {

	public static boolean estaDentro(EntityData e1, EntityData e2) {
		boolean p = false;

		if ((e1.getLocation().x == e2.getLocation().x)
				&& (e1.getLocation().y == e2.getLocation().y)
				&& (e1.getLocation().z == e2.getLocation().z)) {
			p = true;
		}
		return p;

	}
	
	public static Float obtieneAceleracion(ArrayList<Float> lista){
		float acu = 0;
		//El primer valor no es interesante debido a que va a sumar en el acumulador la posicin donde est.
		for(int i = 1; i < lista.size(); i++){
			acu = lista.get(i) + acu;
		}
		
		return Math.abs(acu);
	}
	
	public static Float obtieneOrientacion(ArrayList<Float> lista){
		float dif = 0;
		float f1 = 0;
		float f2 = 0;
		if (lista.size() != 0) {
			f1 = lista.get(0);
			f2 = lista.get(lista.size() - 1);
			dif = f2 - f1;
		}
		return f2;
	}

	public static ArrayList<Float> calculaMovimiento(Float ac_x, Float ac_y, Float ac_z, Float or_x, Float or_y, Float or_z) {
		ArrayList<Float> movimiento = new ArrayList<Float>();
		float x, y, z;
		float cte = 1f / 90;

		//Clculo preliminar x respecto de la orientacin circular
		if (or_x >= 0 && or_x < 90) {

			x = 0f + (cte * (or_x - 0));

		} else if (or_x >= 90 && or_x < 180) {

			x = 1f - (cte * (or_x - 90));

		} else if (or_x >= 180 && or_x < 270) {

			x = 0f - (cte * (or_x - 180));

		} else {

			x = -1f + (cte * (or_x - 270));

		}

		//Clculo preliminar z respecto de la orientacin circular
		if (or_x >= 0 && or_x < 90) {

			z = 1f - (cte * (or_x - 0));

		} else if (or_x >= 90 && or_x < 180) {

			z = 0f - (cte * (or_x - 90));

		} else if (or_x >= 180 && or_x < 270) {

			z = -1f + (cte * (or_x - 180));

		} else {

			z = 0f + (cte * (or_x - 270));

		}

		//Clculo preliminar y respecto de la orientacin ecuador
		if (or_y >= -90 && or_y <= 90) {

			y = cte * or_y;

		}else{
			y = 0.0f;
		}

		// Calculamos movimiento de x y z segn y. abs_y va del 0 al 90.
		// Si abs_y tiende a 0, factor de multiplicacin de x y z tiende a 1.
		// Si abs_y tiende a 90, factor de multiplicacin de x y z tiende a 0.
		Float abs_y = Math.abs(or_y);
		if (abs_y < 90) {
			
			Float fm = cte * (90 - abs_y);
			x = fm * x * ac_y;
			y = y * ac_z;
			z = fm * z * ac_y;
		} else {
			
			x = 0.0f;
			y = 0.0f;
			z = 0.0f;
		}

		movimiento.add(x);
		movimiento.add(y);
		movimiento.add(z);

		return movimiento;
	}

}
