package es.virtualgolf.views;

import java.util.ArrayList;
import java.util.List;

import es.ucm.look.data.EntityData;
import es.virtualgolf.tools.BotonPersonalizado;
import es.virtualgolf.tools.Operaciones;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Parcelable;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class SensoresAct extends Activity implements SensorEventListener {
    private long ac_last_update = 0, ac_last_movement = 0, or_last_update = 0, or_last_movement = 0;
    private float ac_prevX = 0, ac_prevY = 0, ac_prevZ = 0, or_prevX = 0, or_prevY = 0, or_prevZ = 0;
    private float ac_curX = 0, ac_curY = 0, ac_curZ = 0, or_curX = 0, or_curY = 0, or_curZ = 0;
    private boolean boton = false;
    private BotonPersonalizado mMyButton;
    private Handler mHandler;
    private ArrayList<Float> ac_listaX = new ArrayList<Float>();
    private ArrayList<Float> ac_listaY = new ArrayList<Float>();
    private ArrayList<Float> ac_listaZ = new ArrayList<Float>();
    private ArrayList<Float> or_listaX = new ArrayList<Float>();
    private ArrayList<Float> or_listaY = new ArrayList<Float>();
    private ArrayList<Float> or_listaZ = new ArrayList<Float>();
    private Float x1, x2, y1, y2, z1, z2 = 0.0f;
    private float[] posicion_bola, posicion_banderin;
    private Integer golpes;
    
    public SensoresAct () {
        mHandler = new Handler();
    }
    
    private final Runnable mRunnable = new Runnable() {
        public void run() {
            if (boton) {
                boton = true;
//                mHandler.postDelayed(this, 1000);
                
               mHandler.postDelayed(this, 1);
            }
        }
    };
    	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.sensores_act);        
        this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        
        mMyButton = (BotonPersonalizado) findViewById(R.id.my_button);
        
        mMyButton.setOnLongClickListener(new OnLongClickListener() {            
            public boolean onLongClick(View v) {
                boton = true;
                mHandler.post(mRunnable);
                mMyButton.setBackgroundDrawable(getResources().getDrawable(R.drawable.button_on));
                return true;
            }
        });
        
        mMyButton.setMain(this);
        
        Bundle bundle = this.getIntent().getExtras();
        
        if(bundle != null){
        	posicion_bola = bundle.getFloatArray("posicion_bola");
        	golpes = bundle.getInt("golpes");
        }
    }
    
    public void cancelLongPress() {
        boton = false;
        mMyButton.setBackgroundDrawable(getResources().getDrawable(R.drawable.button_off));
        
        //Creamos el Intent
    	Intent intent = new Intent(SensoresAct.this, PrincipalAct.class);
    	
    	//Creamos la informacin a pasar entre actividades
        Bundle b = new Bundle();
        
        //Capturamos movimientos y se lo aadimos 
        
		ArrayList<Float> movimiento = Operaciones.calculaMovimiento(x1, y1, z1, x2, y2, z2);
		posicion_bola[0] = posicion_bola[0] + movimiento.get(0);
		posicion_bola[1] = posicion_bola[1] + movimiento.get(1);
		posicion_bola[2] = posicion_bola[2] + movimiento.get(2);
		b.putFloatArray("posicion_bola", posicion_bola);
		b.putInt("golpes", golpes);

        //Aadimos la informacin al intent
        intent.putExtras(b);
    	
    	//Iniciamos la nueva actividad
        startActivity(intent);
    }
    
    @Override
    protected void onResume() {
        super.onResume();
        SensorManager sm = (SensorManager) getSystemService(SENSOR_SERVICE);
        List<Sensor> sensor_accelerometer = sm.getSensorList(Sensor.TYPE_ACCELEROMETER);        
        if (sensor_accelerometer.size() > 0) {
        	sm.registerListener(this, sensor_accelerometer.get(0), SensorManager.SENSOR_DELAY_GAME);
        }
        List<Sensor> sensor_orientation = sm.getSensorList(Sensor.TYPE_ORIENTATION);        
        if (sensor_orientation.size() > 0) {
        	sm.registerListener(this, sensor_orientation.get(0), SensorManager.SENSOR_DELAY_GAME);
        }
        
    }
    
    @Override
    protected void onStop() {
    	SensorManager sm = (SensorManager) getSystemService(SENSOR_SERVICE);
        sm.unregisterListener(this);
        super.onStop();
    }

	public void onAccuracyChanged(Sensor sensor, int accuracy) {}

	
	public void onSensorChanged(SensorEvent event) {
		if (boton) {
			synchronized (this) {
				switch (event.sensor.getType()) {
				case Sensor.TYPE_ACCELEROMETER:

					// event.values[0]
					ac_curX = event.values[0];
					// event.values[1]
					ac_curY = event.values[1];
					// event.values[2]
					ac_curZ = event.values[2];

					if (ac_prevX == 0 && ac_prevY == 0 && ac_prevZ == 0) {
						ac_prevX = ac_curX;
						ac_prevY = ac_curY;
						ac_prevZ = ac_curZ;
					}

						float ac_difX = ac_curX - ac_prevX;
						float ac_difY = ac_curY - ac_prevY;
						float ac_difZ = ac_curZ - ac_prevZ;
						
						ac_listaX.add(ac_difX);
						ac_listaY.add(ac_difY);
						ac_listaZ.add(ac_difZ);
						
						ac_prevX = ac_curX;
						ac_prevY = ac_curY;
						ac_prevZ = ac_curZ;
						
					break;
				case Sensor.TYPE_ORIENTATION:

					// event.values[0] = Circular
					or_curX = event.values[0];
					// event.values[1] = Ecuador
					or_curY = event.values[1];
					// event.values[2] = Meridiano
					or_curZ = event.values[2];

					if (or_prevX == 0 && or_prevY == 0 && or_prevZ == 0) {
						or_prevX = or_curX;
						or_prevY = or_curY;
						or_prevZ = or_curZ;
					}

						float or_difX = or_curX - or_prevX;
						float or_difY = or_curY - or_prevY;
						float or_difZ = or_curZ - or_prevZ;
						
						or_listaX.add(or_curX);
						or_listaY.add(or_curY);
						or_listaZ.add(or_curZ);
						
						or_prevX = or_curX;
						or_prevY = or_curY;
						or_prevZ = or_curZ;
						break;
					}
				}
			}
		
		x1 = Operaciones.obtieneAceleracion(ac_listaX);
		y1 = Operaciones.obtieneAceleracion(ac_listaY);
		z1 = Operaciones.obtieneAceleracion(ac_listaZ);
		x2 = Operaciones.obtieneOrientacion(or_listaX);
		y2 = Operaciones.obtieneOrientacion(or_listaY);
		z2 = Operaciones.obtieneOrientacion(or_listaZ);
		
		((TextView) findViewById(R.id.txtAccX)).setText("Acelermetro X: "+ x1 + " m/s");
		((TextView) findViewById(R.id.txtAccY)).setText("Acelermetro Y: "+ y1 + " m/s");
		((TextView) findViewById(R.id.txtAccZ)).setText("Acelermetro Z: "+ z1 + " m/s");
		((TextView) findViewById(R.id.txtOrX)).setText("Orientacin Circular: "+ or_curX + "");
		((TextView) findViewById(R.id.txtOrY)).setText("Orientacin Ecuador: "+ or_curY + "");
		((TextView) findViewById(R.id.txtOrZ)).setText("Orientacin Meridiano: "+ or_curZ + "");
		
		}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

	    if(event.getAction() == KeyEvent.ACTION_DOWN)
	    {
	    	
	    }
	    return false;
	}

}